import{downloadAsDataURL,isEmpty,waitFor,sleep}from"../../base/helpers.mjs";import{ElementBuilder}from"../../base/builder.mjs";import{Controller}from"../base.mjs";import{SimpleNotification}from"../../common/notify.mjs";import{SampleChooserView}from"../../view/samples/chooser.mjs";import{SampleView}from"../../view/samples/viewer.mjs";import{ImageAdjustmentView,ImageFilterView}from"../../view/samples/filter.mjs";import{View}from"../../view/base.mjs";import{ImageView}from"../../view/image.mjs";import{ToolbarView}from"../../view/menu.mjs";import{UpscaleFormView,DownscaleFormView}from"../../forms/enfugue/upscale.mjs";const E=new ElementBuilder;class SamplesController extends Controller{static hideTime=250;static imageAdjustmentWindowWidth=750;static imageAdjustmentWindowHeight=450;static imageFilterWindowWidth=450;static imageFilterWindowHeight=350;static imageUpscaleWindowWidth=300;static imageUpscaleWindowHeight=320;static imageDownscaleWindowWidth=260;static imageDownscaleWindowHeight=210;async prepareImageMenu(i){if(navigator.clipboard&&"function"==typeof ClipboardItem){(await i.addItem("Copy to Clipboard","fa-solid fa-clipboard","c")).onClick((()=>this.copyToClipboard()))}(await i.addItem("Popout Image","fa-solid fa-arrow-up-right-from-square","p")).onClick((()=>this.sendToWindow())),(await i.addItem("Save As","fa-solid fa-floppy-disk","a")).onClick((()=>this.saveToDisk())),(await i.addItem("Adjust Image","fa-solid fa-sliders","j")).onClick((()=>this.startImageAdjustment())),(await i.addItem("Filter Image","fa-solid fa-wand-magic-sparkles","l")).onClick((()=>this.startImageFilter())),(await i.addItem("Edit Image","fa-solid fa-pen-to-square","t")).onClick((()=>this.sendToCanvas())),(await i.addItem("Upscale Image","fa-solid fa-up-right-and-down-left-from-center","u")).onClick((()=>this.startImageUpscale())),(await i.addItem("Downscale Image","fa-solid fa-down-left-and-up-right-to-center","w")).onClick((()=>this.startImageDownscale()))}async prepareVideoMenu(i){(await i.addItem("Popout Video","fa-solid fa-arrow-up-right-from-square","p")).onClick((()=>this.sendVideoToWindow())),(await i.addItem("Save As","fa-solid fa-floppy-disk","a")).onClick((()=>this.saveVideoToDisk())),(await i.addItem("Edit Video","fa-solid fa-pen-to-square","t")).onClick((()=>this.sendVideoToCanvas())),(await i.addItem("Upscale Video","fa-solid fa-up-right-and-down-left-from-center","u")).onClick((()=>this.startVideoUpscale())),(await i.addItem("Get as GIF","fa-solid fa-file-video","g")).onClick((()=>this.getVideoGif()))}async copyToClipboard(){navigator.clipboard.write([new ClipboardItem({"image/png":await this.sampleViewer.getBlob()})]),SimpleNotification.notify("Copied to clipboard!",2e3)}async saveToDisk(){this.application.saveBlobAs("Save Image",await this.sampleViewer.getBlob(),".png")}async saveVideoToDisk(){this.application.saveRemoteAs("Save Video",this.video)}async sendToCanvas(){return await this.application.initializeStateFromImage(this.sampleViewer.getDataURL(),!0,null,null,!1)}async sendVideoToCanvas(){return await this.application.initializeStateFromImage(await downloadAsDataURL(this.video),!0,null,null,!0)}async getVideoGif(){if(isEmpty(this.video)||!this.video.endsWith("mp4"))throw"Video is empty or not a URL.";let i=this.video.substring(0,this.video.length-4)+".gif";window.open(i,"_blank")}async startImageDownscale(){if(this.checkActiveTool("downscale"))return;let i=this.sampleViewer.getDataURL(),e=this.sampleViewer.width,t=this.sampleViewer.height,s=async e=>{let t=new ImageView(this.config,i);await t.waitForLoad(),await t.downscale(e),this.sampleViewer.setImage(t.src),this.application.images.setDimension(t.width,t.height,!1)},a=!1;this.imageDownscaleForm=new DownscaleFormView(this.config),this.imageDownscaleWindow=await this.application.windows.spawnWindow("Downscale Image",this.imageDownscaleForm,this.constructor.imageDownscaleWindowWidth,this.constructor.imageDownscaleWindowHeight),this.imageDownscaleWindow.onClose((()=>{this.imageDownscaleForm=null,this.imageDownscaleWindow=null,a||(this.sampleViewer.setImage(i),this.application.images.setDimension(e,t,!1))})),this.imageDownscaleForm.onChange((async()=>s(this.imageDownscaleForm.values.downscale))),this.imageDownscaleForm.onCancel((()=>this.imageDownscaleWindow.remove())),this.imageDownscaleForm.onSubmit((async i=>{a=!0,this.imageDownscaleWindow.remove()})),s(2)}async startImageUpscale(){this.checkActiveTool("upscale")||(this.imageUpscaleForm=new UpscaleFormView(this.config),this.imageUpscaleWindow=await this.application.windows.spawnWindow("Upscale Image",this.imageUpscaleForm,this.constructor.imageUpscaleWindowWidth,this.constructor.imageUpscaleWindowHeight),this.imageUpscaleWindow.onClose((()=>{this.imageUpscaleForm=null,this.imageUpscaleWindow=null})),this.imageUpscaleForm.onCancel((()=>this.imageUpscaleWindow.remove())),this.imageUpscaleForm.onSubmit((async i=>{await this.application.layers.emptyLayers(),await this.application.images.setDimension(this.sampleViewer.width,this.sampleViewer.height,!1,!0),await this.application.layers.addImageLayer(this.sampleViewer.getDataURL()),this.publish("quickUpscale",i),this.imageUpscaleWindow.remove(),this.showCanvas(),setTimeout((()=>{this.application.publish("tryInvoke")}),1e3)})))}async startVideoUpscale(){this.checkActiveTool("upscale")||(this.videoUpscaleForm=new UpscaleFormView(this.config),this.videoUpscaleWindow=await this.application.windows.spawnWindow("Upscale Video",this.videoUpscaleForm,this.constructor.imageUpscaleWindowWidth,this.constructor.imageUpscaleWindowHeight),this.videoUpscaleWindow.onClose((()=>{this.videoUpscaleForm=null,this.videoUpscaleWindow=null})),this.videoUpscaleForm.onCancel((()=>this.videoUpscaleWindow.remove())),this.videoUpscaleForm.onSubmit((async i=>{await this.application.layers.emptyLayers(),await this.application.images.setDimension(this.sampleViewer.width,this.sampleViewer.height,!1,!0),await this.application.layers.addVideoLayer(await downloadAsDataURL(this.video)),this.publish("quickUpscale",i),this.videoUpscaleWindow.remove(),this.showCanvas(),setTimeout((()=>{this.application.publish("tryInvoke")}),1e3)})))}async startImageFilter(){if(this.checkActiveTool("filter"))return;this.imageFilterView=new ImageFilterView(this.config,this.sampleViewer.getDataURL(),this.sampleViewer.node.element.parentElement),this.imageFilterWindow=await this.application.windows.spawnWindow("Filter Image",this.imageFilterView,this.constructor.imageFilterWindowWidth,this.constructor.imageFilterWindowHeight);let i=()=>{try{this.imageFilterView.removeCanvas()}catch(i){}this.imageFilterView=null,this.imageFilterWindow=null};this.imageFilterWindow.onClose(i),this.imageFilterView.onSave((async()=>{await this.sampleViewer.setImage(this.imageFilterView.getImageSource()),setTimeout((()=>{this.imageFilterWindow.remove(),i()}),150)})),this.imageFilterView.onCancel((()=>{this.imageFilterWindow.remove(),i()}))}async startImageAdjustment(){if(this.checkActiveTool("adjust"))return;this.imageAdjustmentView=new ImageAdjustmentView(this.config,this.sampleViewer.getDataURL(),this.sampleViewer.node.element.parentElement),this.imageAdjustmentWindow=await this.application.windows.spawnWindow("Adjust Image",this.imageAdjustmentView,this.constructor.imageAdjustmentWindowWidth,this.constructor.imageAdjustmentWindowHeight);let i=()=>{try{this.imageAdjustmentView.removeCanvas()}catch(i){}this.imageAdjustmentView=null,this.imageAdjustmentWindow=null};this.imageAdjustmentWindow.onClose(i),this.imageAdjustmentView.onSave((async()=>{await this.sampleViewer.setImage(this.imageAdjustmentView.getImageSource()),setTimeout((()=>{this.imageAdjustmentWindow.remove(),i()}),150)})),this.imageAdjustmentView.onCancel((()=>{this.imageAdjustmentWindow.remove(),i()}))}checkActiveTool(i){return isEmpty(this.imageAdjustmentWindow)?isEmpty(this.imageFilterWindow)?isEmpty(this.imageUpscaleWindow)?!isEmpty(this.imageDownscaleWindow)&&("downscale"!==i?this.notify("warn","Finish Downscaling",`Complete your downscale selection or cancel before trying to ${i}.`):this.imageDownscaleWindow.focus(),!0):("upscale"!==i?this.notify("warn","Finish Upscaling",`Complete your upscale selection or cancel before trying to ${i}.`):this.imageUpscaleWindow.focus(),!0):("filter"!==i?this.notify("warn","Finish Filtering",`Complete filtering before trying to ${i}.`):this.imageFilterWindow.focus(),!0):("adjust"!==i?this.notify("warn","Finish Adjusting",`Complete adjustments before trying to ${i}.`):this.imageAdjustmentWindow.focus(),!0)}async sendToWindow(){const i=URL.createObjectURL(await this.sampleViewer.getBlob());window.open(i,"_blank")}async sendVideoToWindow(){window.open(this.video,"_blank")}async toolbarEntered(){this.stopHideTimer()}async toolbarLeft(){this.startHideTimer()}stopHideTimer(){clearTimeout(this.timer)}startHideTimer(){this.timer=setTimeout((async()=>{(await this.lock.acquire())()}),this.constructor.hideTime)}async onMouseEnter(i){this.stopHideTimer()}async onMouseLeave(i){this.startHideTimer()}get frameTime(){return 1e3/this.playbackRate}get sampleUrls(){return isEmpty(this.samples)?[]:this.isIntermediate?this.samples.map((i=>`${this.model.api.baseUrl}/invocation/intermediates/${i}.png`)):this.samples.map((i=>`${this.model.api.baseUrl}/invocation/images/${i}.png`))}get thumbnailUrls(){return isEmpty(this.samples)?[]:this.isIntermediate?this.samples.map((i=>`${this.model.api.baseUrl}/invocation/intermediates/${i}.png`)):this.samples.map((i=>`${this.model.api.baseUrl}/invocation/thumbnails/${i}.png`))}async spawnVideoPlayer(){isEmpty(this.videoPlayerWindow)?(this.videoPlayerWindow=await this.application.spawnVideoPlayer(this.video),this.videoPlayerWindow.onClose((()=>{delete this.videoPlayerWindow}))):this.videoPlayerWindow.focus()}closeVideoPlayer(){isEmpty(this.videoPlayerWindow)||this.videoPlayerWindow.remove()}setVideo(i){this.video!==i&&this.closeVideoPlayer(),this.video=i,isEmpty(i)?this.videoToolsMenu.hide():(this.videoToolsMenu.show(),this.spawnVideoPlayer())}setSamples(i,e){isEmpty(i)?(this.samples=null,this.images.removeClass("has-sample")):this.samples=i.map((i=>i.split("/").slice(-1)[0].split(".")[0])),this.isIntermediate=!isEmpty(this.samples)&&-1!==i[0].indexOf("intermediate"),this.isAnimation=e,this.sampleChooser.setIsAnimation(e),this.sampleChooser.setSamples(this.thumbnailUrls).then((()=>{this.sampleChooser.setActiveIndex(this.activeIndex,!1)})),this.sampleViewer.setImage(e?this.sampleUrls:isEmpty(this.activeIndex)?null:this.sampleUrls[this.activeIndex]),this.isAnimation&&this.sampleViewer.setFrame(this.activeIndex),isEmpty(this.activeIndex)||(this.isAnimation?(this.imageToolsMenu.hide(),isEmpty(this.video)||this.videoToolsMenu.show()):(this.imageToolsMenu.show(),this.videoToolsMenu.hide()),sleep(100).then((()=>{waitFor((()=>!isEmpty(this.sampleViewer.width))).then((()=>{this.images.setDimension(this.sampleViewer.width,this.sampleViewer.height),this.images.addClass("has-sample")}))})))}setActive(i){this.activeIndex=i,this.isAnimation?(this.sampleChooser.setActiveIndex(i,!1),this.sampleViewer.setFrame(i),isEmpty(i)||(this.imageToolsMenu.hide(),isEmpty(this.video)||this.videoToolsMenu.show())):(this.sampleViewer.setImage(this.sampleUrls[this.activeIndex]),isEmpty(i)||(this.imageToolsMenu.show(),this.videoToolsMenu.hide())),isEmpty(i)?(this.images.removeClass("has-sample"),this.images.setDimension(this.engine.width,this.engine.height),this.sampleViewer.hide()):sleep(100).then((()=>{waitFor((()=>!isEmpty(this.sampleViewer.width))).then((()=>{this.images.setDimension(this.sampleViewer.width,this.sampleViewer.height),this.images.addClass("has-sample")}))}))}tickAnimation(){if(isEmpty(this.samples))return;let i=(new Date).getTime();requestAnimationFrame((()=>{let e=this.activeIndex,t=this.samples.length,s=e+1;if(this.isPlaying){if(s<t)this.setActive(s);else{if(!this.isLooping)return void this.sampleChooser.setPlayAnimation(!1);this.setActive(0)}let e=(new Date).getTime()-i;clearTimeout(this.tick),this.tick=setTimeout((()=>this.tickAnimation()),this.frameTime-e)}}))}async setPlaybackRate(i,e=!0){this.playbackRate=i,e&&this.sampleChooser.setPlaybackRate(i)}async setPlay(i,e=!0){this.isPlaying=i,i?(this.activeIndex>=this.samples.length-1&&this.setActive(0),clearTimeout(this.tick),this.tick=setTimeout((()=>this.tickAnimation()),this.frameTime)):clearTimeout(this.tick),e&&this.sampleChooser.setPlayAnimation(i)}async setLoop(i,e=!0){this.isLooping=i,e&&this.sampleChooser.setLoopAnimation(i)}async setTileHorizontal(i,e=!0){this.tileHorizontal=i,this.sampleViewer.tileHorizontal=i,requestAnimationFrame((()=>{e&&this.sampleChooser.setHorizontalTile(i),this.sampleViewer.checkVisibility()}))}async setTileVertical(i,e=!0){this.tileVertical=i,this.sampleViewer.tileVertical=i,requestAnimationFrame((()=>{e&&this.sampleChooser.setVerticalTile(i),this.sampleViewer.checkVisibility()}))}async showCanvas(i=!0){this.setPlay(!1),this.sampleViewer.hide(),this.imageToolsMenu.hide(),this.videoToolsMenu.hide(),i&&this.sampleChooser.setActiveIndex(null),this.images.setDimension(this.engine.width,this.engine.height)}async initialize(){this.sampleChooser=new SampleChooserView(this.config),this.sampleViewer=new SampleView(this.config),this.sampleChooser.onShowCanvas((()=>this.showCanvas(!1))),this.sampleChooser.onLoopAnimation((i=>this.setLoop(i,!1))),this.sampleChooser.onPlayAnimation((i=>this.setPlay(i,!1))),this.sampleChooser.onTileHorizontal((i=>this.setTileHorizontal(i,!1))),this.sampleChooser.onTileVertical((i=>this.setTileVertical(i,!1))),this.sampleChooser.onSetActive((i=>this.setActive(i,!1))),this.sampleChooser.onSetPlaybackRate((i=>this.setPlaybackRate(i,!1))),this.imageToolsMenu=new ToolbarView(this.config),this.prepareImageMenu(this.imageToolsMenu),this.videoToolsMenu=new ToolbarView(this.config),this.prepareVideoMenu(this.videoToolsMenu),this.activeIndex=0,this.playbackRate=SampleChooserView.playbackRate,this.application.container.appendChild(await this.sampleChooser.render());let i=await this.images.getNode();i.find("enfugue-node-canvas").append(await this.sampleViewer.getNode(),E.div().class("sample-tools-container").content(await this.imageToolsMenu.getNode(),await this.videoToolsMenu.getNode())),i.render()}getDefaultState(){return{samples:{urls:null,active:null,video:null,animation:!1}}}getState(i=!0){return i?{samples:{urls:this.sampleUrls,active:this.activeIndex,animation:this.isAnimation,video:this.video}}:this.getDefaultState()}setState(i){isEmpty(i)||isEmpty(i.samples)||isEmpty(i.samples.urls)?(this.setSamples(null),this.setVideo(null)):(this.activeIndex=i.samples.active,this.setSamples(i.samples.urls,!0===i.samples.animation),this.setVideo(i.samples.video))}}export{SamplesController};
