import{isEmpty,isEquivalent,bindMouseUntilRelease}from"../../base/helpers.mjs";import{View}from"../base.mjs";import{ImageView}from"../image.mjs";import{ElementBuilder}from"../../base/builder.mjs";import{NumberInputView}from"../../forms/input.mjs";const E=new ElementBuilder;class SampleChooserView extends View{static tagName="enfugue-sample-chooser";static showCanvasIcon="fa-solid fa-table-cells";static showCanvasTooltip="Show the canvas, hiding any sample currently visible on-screen and revealing the grid and any nodes you've placed on it.";static loopIcon="fa-solid fa-rotate-left";static loopTooltip="Loop the video, restarting it after it has completed.";static playIcon="fa-solid fa-play";static playTooltip="Play the animation.";static tileVerticalIcon="fa-solid fa-ellipsis-vertical";static tileVerticalTooltip="Show the image tiled vertically.";static tileHorizontalIcon="fa-solid fa-ellipsis";static tileHorizontalTooltip="Show the image tiled horizontally.";static playbackRate=8;static playbackRateTooltip="The playback rate of the animation in frames per second.";static noSamplesLabel="No samples yet. When you generate one or more images, their thumbnails will appear here.";constructor(t,a=[],i=!1){super(t),this.showCanvasCallbacks=[],this.loopAnimationCallbacks=[],this.playAnimationCallbacks=[],this.tileHorizontalCallbacks=[],this.tileVerticalCallbacks=[],this.setActiveCallbacks=[],this.setPlaybackRateCallbacks=[],this.imageViews=[],this.isAnimation=i,this.samples=a,this.activeIndex=0,this.playbackRate=this.constructor.playbackRate,this.playbackRateInput=new NumberInputView(t,"playbackRate",{min:1,max:60,value:this.constructor.playbackRate,tooltip:this.constructor.playbackRateTooltip,allowNull:!1}),this.playbackRateInput.onChange((()=>this.setPlaybackRate(this.playbackRateInput.getValue(),!1)))}onShowCanvas(t){this.showCanvasCallbacks.push(t)}onLoopAnimation(t){this.loopAnimationCallbacks.push(t)}onPlayAnimation(t){this.playAnimationCallbacks.push(t)}onTileHorizontal(t){this.tileHorizontalCallbacks.push(t)}onTileVertical(t){this.tileVerticalCallbacks.push(t)}onSetActive(t){this.setActiveCallbacks.push(t)}onSetPlaybackRate(t){this.setPlaybackRateCallbacks.push(t)}showCanvas(){this.setActiveIndex(null);for(let t of this.showCanvasCallbacks)t()}setIsAnimation(t){this.isAnimation=t,isEmpty(this.node)||(t?this.node.addClass("animation"):this.node.removeClass("animation"))}setHorizontalTile(t,a=!0){for(let a of this.tileHorizontalCallbacks)a(t);if(!isEmpty(this.node)&&a){let a=this.node.find(".tile-horizontal");t?a.addClass("active"):a.removeClass("active")}}setVerticalTile(t,a=!0){for(let a of this.tileVerticalCallbacks)a(t);if(!isEmpty(this.node)&&a){let a=this.node.find(".tile-vertical");t?a.addClass("active"):a.removeClass("active")}}setLoopAnimation(t,a=!0){for(let a of this.loopAnimationCallbacks)a(t);if(!isEmpty(this.node)&&a){let a=this.node.find(".loop");t?a.addClass("active"):a.removeClass("active")}}setPlayAnimation(t,a=!0){for(let a of this.playAnimationCallbacks)a(t);if(!isEmpty(this.node)&&a){let a=this.node.find(".play");t?a.addClass("active"):a.removeClass("active")}}setActiveIndex(t,a=!0){if(this.activeIndex=t,a)for(let a of this.setActiveCallbacks)a(t);if(!isEmpty(this.imageViews))for(let a in this.imageViews){let i=this.imageViews[a];a++==t?i.addClass("active"):i.removeClass("active")}}setPlaybackRate(t,a=!0){this.playbackRate=t;for(let a of this.setPlaybackRateCallbacks)a(t);a&&this.playbackRateInput.setValue(t,!1)}async setSamples(t){let a=!isEquivalent(this.samples,t);if(this.samples=t,!isEmpty(this.node)){let t=await this.node.find(".samples");if(isEmpty(this.samples))t.content(E.div().class("no-samples").content(this.constructor.noSamplesLabel)),this.imageViews=[];else if(a){let t=await this.node.find(".samples"),a=!1;isEmpty(this.imageViews)&&(t.empty(),a=!0);for(let i in this.samples){let s,e,l=this.samples[i];if(this.imageViews.length<=i?(s=new ImageView(this.config,l,!1),await s.waitForLoad(),e=await s.getNode(),e.on("click",(()=>{this.setActiveIndex(i)})),this.imageViews.push(s),t.append(e),a=!0):(s=this.imageViews[i],s.setImage(l),await s.waitForLoad(),e=await s.getNode()),null!==this.activeIndex&&this.activeIndex==i?s.addClass("active"):s.removeClass("active"),this.isAnimation){let t=100/this.samples.length;e.css("width",`${t}%`)}else e.css("width",null)}a&&t.render()}}}async build(){let t=await super.build(),a=E.i().addClass("show-canvas").addClass(this.constructor.showCanvasIcon).data("tooltip",this.constructor.showCanvasTooltip).on("click",(()=>this.showCanvas())),i=E.i().addClass("tile-horizontal").addClass(this.constructor.tileHorizontalIcon).data("tooltip",this.constructor.tileHorizontalTooltip).on("click",(()=>{i.toggleClass("active"),this.setHorizontalTile(i.hasClass("active"),!1)})),s=E.i().addClass("tile-vertical").addClass(this.constructor.tileVerticalIcon).data("tooltip",this.constructor.tileVerticalTooltip).on("click",(()=>{s.toggleClass("active"),this.setVerticalTile(s.hasClass("active"),!1)})),e=E.i().addClass("loop").addClass(this.constructor.loopIcon).data("tooltip",this.constructor.loopTooltip).on("click",(()=>{e.toggleClass("active"),this.setLoopAnimation(e.hasClass("active"),!1)})),l=E.i().addClass("play").addClass(this.constructor.playIcon).data("tooltip",this.constructor.playTooltip).on("click",(()=>{l.toggleClass("active"),this.setPlayAnimation(l.hasClass("active"),!1)})),o=E.div().class("samples"),n=!1,c=t=>{let a=o.element.getBoundingClientRect(),i=t.clientX<a.left?0:t.clientX>a.left+a.width?1:(t.clientX-a.left)/a.width;return Math.min(Math.floor(i*this.samples.length),this.samples.length-1)};if(o.on("wheel",(t=>{t.preventDefault(),o.element.scrollLeft+=t.deltaY/10})).on("mousedown",(t=>{this.isAnimation&&(t.preventDefault(),t.stopPropagation(),n=!0,this.setActiveIndex(c(t)),bindMouseUntilRelease((t=>{n&&this.setActiveIndex(c(t))}),(t=>{n=!1})))})).on("mousemove",(t=>{this.isAnimation&&(t.preventDefault(),t.stopPropagation(),n&&this.setActiveIndex(c(t)))})).on("mouseup",(t=>{this.isAnimation&&(t.preventDefault(),t.stopPropagation(),n=!1)})),isEmpty(this.samples))o.append(E.div().class("no-samples").content(this.constructor.noSamplesLabel));else for(let t in this.samples){let a,i,s=this.samples[t];this.imageViews.length<=t?(a=new ImageView(this.config,s,!1),i=await a.getNode(),i.on("click",(()=>{this.setActiveIndex(t)})),this.imageViews.push(a)):(a=this.imageViews[t],a.setImage(s),i=await a.getNode()),null!==this.activeIndex&&this.activeIndex===t?a.addClass("active"):a.removeClass("active"),o.append(i)}return t.content(a,E.div().class("tile-buttons").content(i,s),o,E.div().class("playback-rate").content(await this.playbackRateInput.getNode(),E.span().content("fps")),e,l),this.isAnimation&&t.addClass("animation"),t}}export{SampleChooserView};
